package com.lzw;

import java.awt.*;
import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.ComponentOrientation;
import java.awt.Dimension;
import java.awt.GridLayout;
import java.awt.TrayIcon.MessageType;
import java.awt.event.*;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.io.*;
import java.net.*;
import java.util.*;
import java.util.prefs.Preferences;
import javax.swing.*;
import javax.swing.BoxLayout;
import javax.swing.JButton;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JTextField;
import javax.swing.SwingConstants;
import javax.swing.border.*;
import javax.swing.border.TitledBorder;
import javax.swing.tree.*;
import com.lzw.dao.Dao;
import com.lzw.frame.TelFrame;
import com.lzw.system.Resource;
import com.lzw.userList.ChatTree;
import com.lzw.userList.User;

public class MainFrame extends JDialog {
	private JTextField ipEndTField;
	private JTextField ipStartTField;
	public static MainFrame frame = null;
	public static TrayIcon trayicon;
	public final static Preferences preferences = Preferences.systemRoot();
	private JLabel resizeHander;
	private JPanel mainPanel;
	private TitlePanel frameTitleLabel;
	private JLabel ipAddLabel;
	private JLabel chatTreeLabel;
	private JPanel panel;;
	private ChatTree chatTree;
	private JPopupMenu popupMenu;
	private JTabbedPane tabbedPane;
	private JToggleButton searchUserButton;
	private JProgressBar progressBar;
	private DatagramSocket ss;
	private final JLabel statusLabel;
	private Stack<String> messageStack;
	private Dao dao;
	private JLabel userInfoButton;
	private ImageIcon userTicon;
	private ImageIcon sysOTicon;
	
	/**
	 * 
	 * @param args
	 */
	public static void main(String args[]) {
		EventQueue.invokeLater(new Runnable() {
			public void run() {
				try {
					UIManager.setLookAndFeel(UIManager.getSystemLookAndFeelClassName());
					MainFrame frame = new MainFrame();
					frame.setVisible(true);
					frame.SystemTrayInitial();// ʼϵͳ
					frame.server();
					frame.startServer();
				} catch (Exception e) {
					e.printStackTrace();
				}
			}
		});
	}
	
	public MainFrame() {
		statusLabel = new JLabel(); // ״̬ǩ
		statusLabel.setHorizontalAlignment(SwingConstants.RIGHT);
		statusLabel.setBackground(new Color(0xE0F0FD));
		frame = this;
		dao = Dao.getDao();
		setBounds(100,100,262,600);
		addWindowListener(new FrameWindowListener());// Ӵ
		userTicon = new ImageIcon(MainFrame.class
				.getResource("/image/tabIcon/tabLeft.png"));
		sysOTicon = new ImageIcon(MainFrame.class
				.getResource("/image/tabIcon/tabLeft2.png"));
		messageStack = new Stack<String>();
		getContentPane().add(getMainPanel());
		initUserInfoButton();// ʼûͷť
		setAlwaysOnTop(true); // ö
		setUndecorated(true);
	}
	
	/**
	 * Socketķ
	 */
	private void startServer() {
		try {// ͨŷ˿
			ss = new DatagramSocket(1111);
		} catch (SocketException e2) {
			if (e2.getMessage().startsWith("Address already in use"))
				showMessageDialog("˿ڱռ,߱ѾС");
			// System.exit(0);
		}
	}
	
	public void setStatic(String str) {// ״̬Ϣ
		if (statusLabel != null)
			statusLabel.setText(str);
	}
	
	private void addUserPopup(Component component, final JPopupMenu popup) {// û˵
		component.addMouseListener(new MouseAdapter() {
			public void mousePressed(MouseEvent e) {
				if (e.isPopupTrigger())
					showMenu(e);
			}
			
			public void mouseReleased(MouseEvent e) {
				if (e.isPopupTrigger())
					showMenu(e);
			}
			
			private void showMenu(MouseEvent e) {
				if (getChatTree().getSelectionPaths() == null) {
					popupMenu.getComponent(0).setEnabled(false);
					popupMenu.getComponent(2).setEnabled(false);
					popupMenu.getComponent(3).setEnabled(false);
					popupMenu.getComponent(4).setEnabled(false);
				} else {
					if (getChatTree().getSelectionPaths().length < 2) {
						popupMenu.getComponent(3).setEnabled(false);
					} else {
						popupMenu.getComponent(3).setEnabled(true);
					}
					popupMenu.getComponent(0).setEnabled(true);
					popupMenu.getComponent(2).setEnabled(true);
					popupMenu.getComponent(4).setEnabled(true);
				}
				popup.show(e.getComponent(), e.getX(), e.getY());
			}
		});
	}
	
	private PopupMenu createMenu() { // ϵͳ˵ķ
		PopupMenu menu = new PopupMenu();
		MenuItem exitItem = new MenuItem("˳");
		exitItem.addActionListener(new ActionListener() { // ϵͳ˳¼
					public void actionPerformed(ActionEvent e) {
						System.exit(0);
					}
				});
		MenuItem openItem = new MenuItem("");
		openItem.addActionListener(new ActionListener() {// ϵͳ򿪲˵¼
					public void actionPerformed(ActionEvent e) {
						if (!isVisible()) {
							setVisible(true);
							toFront();
						} else
							toFront();
					}
				});
		menu.add(openItem);
		menu.addSeparator();
		menu.add(exitItem);
		return menu;
	}
	
	private JScrollPane createSysToolPanel() {// ϵͳ
		JPanel sysToolPanel = new JPanel(); // ϵͳ
		sysToolPanel.setOpaque(false);
		sysToolPanel.setLayout(new BorderLayout());
		JScrollPane sysToolScrollPanel = new JScrollPane();
		sysToolScrollPanel.setOpaque(false);
		sysToolScrollPanel
				.setHorizontalScrollBarPolicy(ScrollPaneConstants.HORIZONTAL_SCROLLBAR_NEVER);
		sysToolScrollPanel.setBorder(new EmptyBorder(0, 0, 0, 0));
		sysToolScrollPanel.setViewportView(sysToolPanel);
		sysToolPanel.setBorder(new BevelBorder(BevelBorder.LOWERED));
		
		JPanel searchUserPanel = new JPanel(); // û
		searchUserPanel.setOpaque(false);
		sysToolPanel.add(searchUserPanel);
		searchUserPanel.setLayout(new BorderLayout());
		final JPanel searchControlPanel = new JPanel();
		searchControlPanel.setOpaque(false);
		searchControlPanel.setLayout(new GridLayout(0, 1));
		searchUserPanel.add(searchControlPanel, BorderLayout.SOUTH);
		final JList searchUserList = new JList(new String[] { "ûб" });// ûб
		searchUserList.setOpaque(false);
		final JScrollPane scrollPane_2 = new JScrollPane(searchUserList);
		scrollPane_2.setOpaque(false);
		scrollPane_2.setDoubleBuffered(true);
		searchUserPanel.add(scrollPane_2);
		scrollPane_2.getViewport().setOpaque(false);
		searchUserList.setBorder(new BevelBorder(BevelBorder.LOWERED));
		searchUserButton = new JToggleButton();
		searchUserButton.setOpaque(false);
		searchUserButton.setText("û");
		searchUserButton.addActionListener(new SearchUserActionListener(
				searchUserList));
		searchControlPanel.add(progressBar);
		searchControlPanel.add(searchUserButton);
		searchUserPanel.setBorder(new TitledBorder("û"));
		
		final JPanel sysSetPanel = new JPanel();
		sysSetPanel.setOpaque(false);
		sysSetPanel.setLayout(new BoxLayout(sysSetPanel, BoxLayout.Y_AXIS));
		sysToolPanel.add(sysSetPanel, BorderLayout.SOUTH);
		
		final JPanel ipPanel = new JPanel();
		ipPanel.setOpaque(false);
		ipPanel.setBorder(new TitledBorder(null, "IPΧ",
				TitledBorder.DEFAULT_JUSTIFICATION,
				TitledBorder.DEFAULT_POSITION, null, null));
		final GridLayout gridLayout = new GridLayout(0, 1);
		gridLayout.setVgap(5);
		ipPanel.setLayout(gridLayout);
		ipPanel.setMaximumSize(new Dimension(600, 90));
		sysSetPanel.add(ipPanel);
		
		final JPanel panel_5 = new JPanel();
		panel_5.setOpaque(false);
		panel_5.setLayout(new BoxLayout(panel_5, BoxLayout.X_AXIS));
		ipPanel.add(panel_5);
		
		final JLabel label_1 = new JLabel();
		label_1.setText("ʼIP");
		panel_5.add(label_1);
		
		ipStartTField = new JTextField();
		ipStartTField.setText("192.168.0.1");
		panel_5.add(ipStartTField);
		
		final JPanel panel_6 = new JPanel();
		panel_6.setOpaque(false);
		panel_6.setLayout(new BoxLayout(panel_6, BoxLayout.X_AXIS));
		ipPanel.add(panel_6);
		
		final JLabel label_2 = new JLabel();
		label_2.setText("ֹIP");
		panel_6.add(label_2);
		
		ipEndTField = new JTextField();
		ipEndTField.setText("192.168.1.255");
		panel_6.add(ipEndTField);
		
		final JButton ipOKButton = new JButton();
		ipOKButton.addActionListener(new ActionListener() {
			public void actionPerformed(final ActionEvent e) {
				do_ipOKButton_actionPerformed(e);
			}
		});
		ipOKButton.setActionCommand("ipOK");
		ipOKButton.setText("ȷ");
		sysSetPanel.add(ipOKButton);
		
		sysToolScrollPanel.getViewport().setOpaque(false);
		return sysToolScrollPanel;
	}
	
	private JScrollPane getUserList() {// ûб
		JScrollPane sPane = new JScrollPane();
		sPane.setOpaque(false);
		sPane.setDoubleBuffered(true);
		sPane.setBorder(new BevelBorder(BevelBorder.LOWERED));
		sPane
				.setHorizontalScrollBarPolicy(ScrollPaneConstants.HORIZONTAL_SCROLLBAR_NEVER);
		sPane.setColumnHeaderView(getChatTreeLabel());
		sPane.setViewportView(getChatTree());
		sPane.setCorner(JScrollPane.UPPER_RIGHT_CORNER, new UserListLabel());
		return sPane;
	}
	
	private void initUserInfoButton() {// ʼûϢť
		try {
			String ip = InetAddress.getLocalHost().getHostAddress();
			User user = dao.getUser(ip);
			userInfoButton = new JLabel();
			userInfoButton.setFocusable(false);
			JPanel borderPanel = new JPanel();
			borderPanel.add(userInfoButton);
			borderPanel.setOpaque(false);
			panel.add(borderPanel, BorderLayout.WEST);
			userInfoButton.setOpaque(false);
			userInfoButton.setBackground(new Color(0xF0EFEF));
			ImageIcon userIcon=new ImageIcon(getClass().getResource("/image/userIcon.png"));
			userInfoButton.setIcon(userIcon);
			userInfoButton.setText(user.getName());
			userInfoButton.setIconTextGap(JLabel.RIGHT);
			userInfoButton.setToolTipText(user.getTipText());
			userInfoButton.getParent().doLayout();
			getIpAddLabel().setText("IPַ" + user.getIp());
		} catch (UnknownHostException e1) {
			e1.printStackTrace();
		}
	}
	
	private void server() {// ͨż߳
		new Thread(new Runnable() {
			public void run() {
				while (true) {
					if (ss != null) {
						byte[] buf = new byte[4096];
						DatagramPacket dp = new DatagramPacket(buf, buf.length);
						try {
							ss.receive(dp);
						} catch (IOException e) {
							e.printStackTrace();
						}
						TelFrame.getInstance(ss, dp, getChatTree());
					}
				}
			}
		}).start();
	}
	
	private String showInputDialog(String str) { // ʾԻ
		String newName = JOptionPane.showInputDialog(this,
				"<html><font color=red>" + str + "</font></html>");
		return newName;
	}
	
	private void showMessageDialog(String mess) {
		JOptionPane.showMessageDialog(this, mess);
	}
	
	private void SystemTrayInitial() { // ϵͳʼ
		if (!SystemTray.isSupported()) // жϵǰϵͳǷ֧ϵͳ
			return;
		try {
			String title = "ҵͨŹϵͳ";
			String company = "޾ʹá";
			SystemTray sysTray = SystemTray.getSystemTray();
			Image image = Toolkit.getDefaultToolkit().getImage(
					MainFrame.class.getResource("/image/sysTray.png"));// ϵͳͼ
			trayicon = new TrayIcon(image, title + "\n" + company, createMenu());
			trayicon.setImageAutoSize(true);
			trayicon.addActionListener(new ActionListener() {
				public void actionPerformed(ActionEvent e) {
					setVisible(true);
					toFront();
				}
			});
			sysTray.add(trayicon);
			trayicon.displayMessage(title, company, MessageType.INFO);
		} catch (Exception e) {
			e.printStackTrace();
		}
	}
	
	protected ChatTree getChatTree() {
		if (chatTree == null) {
			chatTree = new ChatTree();
			addUserPopup(chatTree, getPopupMenu());// Ϊûӵ˵
			chatTree.addMouseListener(new ChatTreeMouseListener());
		}
		return chatTree;
	}
	
	protected JLabel getChatTreeLabel() {
		if (chatTreeLabel == null) {
			chatTreeLabel = new UserListLabel();
			chatTreeLabel.setPreferredSize(new Dimension(0, 30));
			chatTreeLabel.setOpaque(true);
			chatTreeLabel.setText("ϵб");
		}
		return chatTreeLabel;
	}
	
	
	/**
	 * 㴰ķ
	 * @return
	 */
	protected TitlePanel getFrameTitlePanel() {
		if (frameTitleLabel == null) {
			final Point cp = new Point(-1,-1);
			frameTitleLabel = new TitlePanel();
			frameTitleLabel.setIcon(new ImageIcon(getClass().getResource(
					"/image/sysTray.png")));
			frameTitleLabel.addMouseListener(new MouseAdapter() {
				public void mouseReleased(MouseEvent e) {
					cp.setLocation(-1, -1);
				}
			});
			frameTitleLabel.addMouseMotionListener(new MouseMotionAdapter() {
				public void mouseDragged(MouseEvent e) {
					if ((e.getModifiers() & e.BUTTON1_MASK) == e.BUTTON1_MASK) {
						if (cp.getX() == -1)
							cp.setLocation(e.getPoint());
						Point sp = e.getLocationOnScreen();
						sp.setLocation(sp.x - cp.x, sp.y - cp.y);
						MainFrame.this.setLocation(sp);
					}
				}
			});
			frameTitleLabel.setText("EQҵͨŹϵͳ");
			frameTitleLabel.setPreferredSize(new Dimension(0, 40));
			frameTitleLabel.setAutoscrolls(true);
		}
		return frameTitleLabel;
	}
	
	protected JLabel getIpAddLabel() {
		if (ipAddLabel == null) {
			ipAddLabel = new JLabel();
			ipAddLabel.setText("IPַ");
		}
		return ipAddLabel;
	}
	
	protected JPanel getMainPanel() {
		if (mainPanel == null) {
			mainPanel = new JPanel();
			mainPanel.setBackground(new Color(0xE0F0FD));
			final LineBorder lineBorder = new LineBorder(new Color(0x82BCD8),
					3, true);
			mainPanel.setBorder(lineBorder);
			mainPanel.setLayout(new BorderLayout());
			final JPanel bannerPanel = new JPanel();
			bannerPanel.setOpaque(false);
			mainPanel.add(bannerPanel, BorderLayout.NORTH);
			final BorderLayout borderLayout = new BorderLayout();
			borderLayout.setHgap(3);
			bannerPanel.setLayout(borderLayout);
			bannerPanel.add(getPanel());
			bannerPanel.add(getFrameTitlePanel(), BorderLayout.NORTH);
			tabbedPane = new JTabbedPane();
			tabbedPane.setBackground(new Color(0xE0F0FD));
			tabbedPane.setTabPlacement(SwingConstants.LEFT);
			mainPanel.add(tabbedPane);
			
			progressBar = new JProgressBar();
			progressBar.setOpaque(false);
			progressBar.setBorder(new BevelBorder(BevelBorder.LOWERED));
			tabbedPane.addTab("", userTicon, getUserList(), "ûб");
			tabbedPane.addTab(null, sysOTicon, createSysToolPanel(), "ϵͳ");
			JPanel statePanel = new JPanel();
			statePanel.setPreferredSize(new Dimension(0, 35));
			statePanel.setOpaque(false);
			mainPanel.add(statePanel, BorderLayout.SOUTH);
			statePanel.setLayout(new BorderLayout());
			statusLabel.setText("" + getChatTree().getRowCount());
			statePanel.add(statusLabel);
			statePanel.add(getResizeHander(), BorderLayout.EAST);
		}
		return mainPanel;
	}
	
	
	
	protected JPanel getPanel() {
		if (panel == null) {
			panel = new IPPanel();
			panel.setPreferredSize(new Dimension(0, 70));
			panel.setOpaque(false);
			final BorderLayout borderLayout = new BorderLayout();
			borderLayout.setHgap(10);
			panel.setLayout(borderLayout);
			panel.add(getIpAddLabel(), BorderLayout.CENTER);
		}
		return panel;
	}
	
	protected JPopupMenu getPopupMenu() {// û˵
		if (popupMenu == null) {
			popupMenu = new JPopupMenu();
			popupMenu.setOpaque(false);
		}
		final JMenuItem rename = new JMenuItem();
		popupMenu.add(rename);
		rename.addActionListener(new RenameActionListener());
		rename.setText("");
		final JMenuItem addUser = new JMenuItem();
		addUser.addActionListener(new AddUserActionListener());
		popupMenu.add(addUser);
		addUser.setText("û");
		final JMenuItem delUser = new JMenuItem();
		delUser.addActionListener(new delUserActionListener());
		popupMenu.add(delUser);
		delUser.setText("ɾû");
		final JMenuItem messagerGroupSend = new JMenuItem();
		messagerGroupSend
				.addActionListener(new messagerGroupSendActionListener());
		messagerGroupSend.setText("ʹȺ");
		popupMenu.add(messagerGroupSend);
		final JMenuItem accessComputerFolder = new JMenuItem("Դ");
		accessComputerFolder.setActionCommand("computer");
		popupMenu.add(accessComputerFolder);
		accessComputerFolder
				.addActionListener(new accessFolderActionListener());
		return popupMenu;
	}
	
	protected JLabel getResizeHander() {
		if (resizeHander == null) {
			resizeHander = new JLabel();
			resizeHander.setIcon(new ImageIcon(getClass().getResource(
					"/frameAdj.png")));
			resizeHander.setVerticalAlignment(JLabel.BOTTOM);
			Cursor predefinedCursor = Cursor
					.getPredefinedCursor(Cursor.SE_RESIZE_CURSOR);
			resizeHander.setCursor(predefinedCursor);
			resizeHander.addMouseMotionListener(new MouseMotionAdapter() {
				public void mouseDragged(MouseEvent e) {
					Point mp = e.getPoint();
					Dimension frameSize = getSize();
					Dimension iconSize = resizeHander.getSize();
					int iconHeight = iconSize.height;
					int iconWidth = iconSize.width;
					int width = frameSize.width-iconWidth + mp.x;
					int height = frameSize.height-iconHeight + mp.y;
					setSize(width, height);
				}
			});
		}
		return resizeHander;
	}
	
	
	private class accessFolderActionListener implements ActionListener {// Դ
		public void actionPerformed(final ActionEvent e) {
			TreePath path = getChatTree().getSelectionPath();
			if (path == null)
				return;
			DefaultMutableTreeNode node = (DefaultMutableTreeNode) path
					.getLastPathComponent();
			User user = (User) node.getUserObject();
			String ip = "\\\\" + user.getIp();
			String command = e.getActionCommand();
			if (command.equals("computer")) {
				Resource.startFolder(ip);
			}
		}
	}
	
	private class AddUserActionListener implements ActionListener {
		public void actionPerformed(final ActionEvent e) {// û
			String ip = JOptionPane
					.showInputDialog(MainFrame.this, "ûIPַ");
			if (ip != null)
				getChatTree().addUser(ip, "add");
		}
	}
	
	private class ChatTreeMouseListener extends MouseAdapter { // ûбļ
		public void mouseClicked(final MouseEvent e) {
			if (e.getClickCount() == 2) {
				TreePath path = getChatTree().getSelectionPath();
				if (path == null)
					return;
				DefaultMutableTreeNode node = (DefaultMutableTreeNode) path
						.getLastPathComponent();
				User user = (User) node.getUserObject();
				try {
					TelFrame.getInstance(ss, new DatagramPacket(new byte[0], 0,
							InetAddress.getByName(user.getIp()), 1111),
							getChatTree());
				} catch (IOException e1) {
					e1.printStackTrace();
				}
			}
		}
	}
	
	private class delUserActionListener implements ActionListener {
		public void actionPerformed(final ActionEvent e) {// ɾû
			getChatTree().delUser();
		}
	}
	
	private class FrameWindowListener extends WindowAdapter {
		public void windowClosing(final WindowEvent e) {// ϵͳر¼
			setVisible(false);
		}
	}
	
	private class messagerGroupSendActionListener implements ActionListener {// ʹȺ
		public void actionPerformed(final ActionEvent e) {
			String message = JOptionPane.showInputDialog(MainFrame.this,
					"ȺϢ", "ʹȺ", JOptionPane.INFORMATION_MESSAGE);
			if (message != null && !message.equals("")) {
				TreePath[] selectionPaths = getChatTree().getSelectionPaths();
				Resource.sendGroupMessenger(selectionPaths, message);
			} else if (message != null && message.isEmpty()) {
				JOptionPane.showMessageDialog(MainFrame.this, "ܷͿϢ");
			}
		}
	}
	
	private class RenameActionListener implements ActionListener {// 
		public void actionPerformed(final ActionEvent e) {
			TreePath path = getChatTree().getSelectionPath();
			if (path == null)
				return;
			DefaultMutableTreeNode node = (DefaultMutableTreeNode) path
					.getLastPathComponent();
			User user = (User) node.getUserObject();
			String newName = showInputDialog(user.getName());
			if (newName != null && !newName.isEmpty()) {
				user.setName(newName);
				dao.updateUser(user);
				DefaultTreeModel model = (DefaultTreeModel) getChatTree()
						.getModel();
				model.reload();
				getChatTree().setSelectionPath(path);
				initUserInfoButton();
			}
		}
	}
	
	class SearchUserActionListener implements ActionListener {
		private final JList list;
		
		SearchUserActionListener(JList list) {
			this.list = list;
		}
		
		public void actionPerformed(ActionEvent e) {
			if (searchUserButton.isSelected()) {
				searchUserButton.setText("ֹͣ");
				new Thread(new Runnable() {
					public void run() {
						Resource.searchUsers(getChatTree(), progressBar, list,
								searchUserButton);
					}
				}).start();
			} else
				searchUserButton.setText("û");
		}
	}
	
	protected void do_ipOKButton_actionPerformed(final ActionEvent e) {
		String command = e.getActionCommand();
		if (command.equals("ipOK")) {
			String ipStart = ipStartTField.getText();
			String ipEnd = ipEndTField.getText();
			try {
				InetAddress.getByName(ipStart);
				InetAddress.getByName(ipEnd);
			} catch (UnknownHostException e1) {
				JOptionPane.showMessageDialog(MainFrame.this, "IPַʽ");
				return;
			}
			preferences.put("ipStart", ipStart); // ϵͳ·
			preferences.put("ipEnd", ipEnd);// ϵͳ·
			JOptionPane.showMessageDialog(MainFrame.this, "IPñ");
		}
	}
}