package com.lzw;

import java.awt.BorderLayout;
import java.awt.Dimension;
import java.awt.Font;
import java.awt.Graphics;
import java.awt.Image;
import java.awt.Insets;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.net.URL;

import javax.swing.ImageIcon;
import javax.swing.JButton;
import javax.swing.JLabel;
import javax.swing.JPanel;

public class TitlePanel extends JPanel {
	private Image background;
	private JLabel label=new JLabel();
	private JButton closeButton;
	public TitlePanel() {
		super();
		setLayout(new BorderLayout());
		URL url = getClass().getResource("/image/titleBackground.png");
		background=new ImageIcon(url).getImage();
		label.setFont(new Font("", Font.BOLD, 14));
		add(label,BorderLayout.CENTER);
		add(getCloseButton(),BorderLayout.EAST);
	}
	protected void paintComponent(Graphics g) {
		super.paintComponent(g);
		g.drawImage(background, 0, 0, getWidth(), getHeight(), this);
	}
	@Override
	public void paint(Graphics g) {
		super.paint(g);
	}
	public void setText(String text){
		label.setText(text);
	}
	public void setIcon(ImageIcon icon){
		label.setIcon(icon);
	}
	private JButton getCloseButton() {
		if (closeButton == null) {
			closeButton = new JButton();
			closeButton.setMargin(new Insets(0, 0, 0, 0));
			closeButton.setContentAreaFilled(false);
			closeButton.setBorderPainted(false);
			closeButton.setIcon(new ImageIcon(getClass().getResource(
					"/closeWB.png")));
			closeButton.setRolloverIcon(new ImageIcon(getClass().getResource(
					"/closeWB_R.png")));
			closeButton.setFocusable(false);
			closeButton.addActionListener(new ActionListener() {
				public void actionPerformed(ActionEvent e) {
					getRootPane().getParent().setVisible(false);		// ض㴰
				}
			});
		}
		return closeButton;
	}
}
