package com.lzw.frame;
import java.awt.*;
import java.awt.event.*;
import java.io.IOException;
import java.net.*;
import java.util.*;

import javax.swing.*;
import javax.swing.border.*;
import javax.swing.text.*;

import com.lzw.MainFrame;
import com.lzw.dao.Dao;
import com.lzw.system.Resource;
import com.lzw.userList.*;
import com.swtdesigner.SwingResourceManager;
public class TelFrame extends JFrame {
	private JPanel content;
	private JButton closeButton;
	private JLabel label_3;
	private JPanel titlePanel;
	private Dao dao;
	private User user;
	private JTextPane receiveText = new JTextPane();
	private JScrollPane scrollPane = new JScrollPane();
	private JTextPane sendText = new JTextPane();
	private JScrollPane scrollPane_1 = new JScrollPane();
	private JSplitPane mainPanel = new JSplitPane();
	private JButton sendButton = new JButton();
	private final JButton messageButton = new JButton();
	private JPanel panel = new JPanel();
	private final static Map<String, TelFrame> instance = new HashMap<String, TelFrame>();
	private final JCheckBox messageMode = new JCheckBox();
	private JToolBar toolBar = new JToolBar();
	private JToggleButton toolFontButton = new JToggleButton();
	private JButton toolFaceButton = new JButton();
	private JButton button = new JButton();
	private JButton button_3 = new JButton();
	private final JPanel toolPanel = new ToolPanel();
	private JPanel panel_2 = new JPanel();
	private JPanel panel_1 = new JPanel();
	private final JLabel label_1 = new JLabel();
	private JPanel infoPanel = new JPanel();
	private byte[] buf;
	private DatagramSocket ss;
	private String ip;
	private DatagramPacket dp;
	private TelFrame frame;
	private ChatTree tree;
	private Point cp;
	private ImageIcon toolbarFaceIcon = new ImageIcon(MainFrame.class
			.getResource("/image/telFrameImage/toolbarImage/ToolbarFace.png"));
	private toolbarActionListener toolListener;
	private ImageIcon toolbarFontIcon;
	private ImageIcon toolbarPictureIcon;
	private ImageIcon toolbarSceneIcon;
	public static synchronized TelFrame getInstance(DatagramSocket ssArg,
			DatagramPacket dp, ChatTree treeArg) {
		String tmpIp = dp.getAddress().getHostAddress();
		if (!instance.containsKey(tmpIp)) {
			TelFrame frame = new TelFrame(ssArg, dp, treeArg);
			instance.put(tmpIp, frame);
			frame.receiveInfo(treeArg);
			if (!frame.isVisible()) {
				frame.setVisible(true);
			}
			frame.setState(JFrame.NORMAL);
			frame.toFront();
			return frame;
		} else {
			TelFrame frame = instance.get(tmpIp);
			frame.setBufs(dp.getData());
			frame.receiveInfo(treeArg);
			if (!frame.isVisible()) {
				frame.setVisible(true);
			}
			frame.setState(JFrame.NORMAL);
			frame.toFront();
			return frame;
		}
	}

	public TelFrame(DatagramSocket ssArg, DatagramPacket dpArg,
			final ChatTree treeArg) {
		setDefaultCloseOperation(JFrame.DISPOSE_ON_CLOSE);
		this.tree = treeArg;
		ip = dpArg.getAddress().getHostAddress();
		dao = Dao.getDao();
		user = dao.getUser(ip);
		frame = this;
		ss = ssArg;
		dp = dpArg;
		buf = dp.getData();
		try {
			setBounds(300, 100, 521, 424);
			final FlowLayout flowLayout = new FlowLayout();
			flowLayout.setHgap(4);
			flowLayout.setAlignment(FlowLayout.LEFT);
			flowLayout.setVgap(0);

			toolListener = new toolbarActionListener();
			toolbarFontIcon = new ImageIcon(
					MainFrame.class
							.getResource("/image/telFrameImage/toolbarImage/ToolbarFont.png"));
			toolbarPictureIcon = new ImageIcon(
					MainFrame.class
							.getResource("/image/telFrameImage/toolbarImage/ToolbarPicture.png"));
			toolbarSceneIcon = new ImageIcon(
					MainFrame.class
							.getResource("/image/telFrameImage/toolbarImage/ToolbarScene.png"));
			addWindowListener(new TelFrameClosing(tree));
		} catch (Exception e) {
			e.printStackTrace();
		}
		setUndecorated(true);
		setTitle("롺" + user + "ͨѶ");
		getContentPane().add(getContent());
		setVisible(true);
	}

	private void receiveInfo(final ChatTree tree) {// Ϣ
		if (buf.length > 0) {
			String rText = new String(buf).replace("" + (char) 0, "");
			String hostAddress = dp.getAddress().getHostAddress();
			String info = dao.getUser(hostAddress).getName();
			info = info + "  (" + new Date().toLocaleString() + ")";
			appendReceiveText(info, Color.BLUE);
			appendReceiveText(rText + "\n", null);
		}
	}

	class SendActionListener implements ActionListener {
		public void actionPerformed(final ActionEvent e) {
			String sendInfo = getSendInfo();
			if (sendInfo == null)
				return;
			insertUserInfoToReceiveText(tree);
			appendReceiveText(sendInfo + "\n", null);
			byte[] tmpBuf = sendInfo.getBytes();
			DatagramPacket tdp = null;
			try {
				tdp = new DatagramPacket(tmpBuf, tmpBuf.length,
						new InetSocketAddress(ip, 1111));
				ss.send(tdp);
			} catch (SocketException e2) {
				e2.printStackTrace();
			} catch (IOException e1) {
				e1.printStackTrace();
				JOptionPane.showMessageDialog(TelFrame.this, e1.getMessage());
			}
			sendText.setText(null);
			sendText.requestFocus();
			if (messageMode.isSelected())
				setState(ICONIFIED);
		}
	}

	class toolbarActionListener implements ActionListener {
		public void actionPerformed(final ActionEvent e) {
			JOptionPane.showMessageDialog(TelFrame.this, "˹ڽС");
		}
	}

	private final class TelFrameClosing extends WindowAdapter {
		private final JTree tree;

		private TelFrameClosing(JTree tree) {
			this.tree = tree;
		}

		public void windowClosing(final WindowEvent e) {
			tree.setSelectionPath(null);
			TelFrame.this.setState(ICONIFIED);
			TelFrame.this.dispose();
		}
	}

	private class MessageButtonActionListener implements ActionListener {// ʹť
		public void actionPerformed(final ActionEvent e) {
			try {
				Document doc = sendText.getDocument();
				String sendInfo = doc.getText(0, doc.getLength());
				if (sendInfo.equals("") || sendInfo == null) {
					JOptionPane.showMessageDialog(TelFrame.this, "ܷͿϢ");
					return;
				}
				insertUserInfoToReceiveText(tree);
				appendReceiveText(sendInfo, null);
				Resource.sendMessenger(user, sendInfo, frame);
				sendText.setText(null);
				sendText.requestFocus();
			} catch (BadLocationException e1) {
				e1.printStackTrace();
			}
		}
	}
	private class SendTextKeyListener extends KeyAdapter {
		public void keyPressed(KeyEvent e) {
			if (e.isControlDown() && e.getKeyCode() == 10)
				sendButton.doClick();
			else if (e.isShiftDown() && e.getKeyCode() == 10)
				messageButton.doClick();
		}
	}

	public JButton getSendButton() {
		return sendButton;
	}

	public JTextPane getReceiveText() {
		return receiveText;
	}

	public void setBufs(byte[] bufs) {
		this.buf = bufs;
	}

	public String getSendInfo() {
		String sendInfo = "";
		Document doc = sendText.getDocument();
		try {
			sendInfo = doc.getText(0, doc.getLength());
		} catch (BadLocationException e) {
			e.printStackTrace();
		}
		if (sendInfo.equals("")) {
			JOptionPane.showMessageDialog(TelFrame.this, "ܷͿϢ");
			return null;
		}
		return sendInfo;
	}

	private void insertUserInfoToReceiveText(final ChatTree tree) {
		String info = null;
		try {
			String hostAddress = InetAddress.getLocalHost().getHostAddress();
			info = dao.getUser(hostAddress).getName();
		} catch (UnknownHostException e1) {
			e1.printStackTrace();
		}
		info = info + "  (" + new Date().toLocaleString() + ")";
		appendReceiveText(info, new Color(68, 184, 29));
	}

	public JTextPane getSendText() {
		return sendText;
	}

	public void appendReceiveText(String sendInfo, Color color) {
		Style style = receiveText.addStyle("title", null);
		if (color != null) {
			StyleConstants.setForeground(style, color);
		} else {
			StyleConstants.setForeground(style, Color.BLACK);
		}
		receiveText.setEditable(true);
		receiveText.setCaretPosition(receiveText.getDocument().getLength());
		receiveText.setCharacterAttributes(style, false);
		receiveText.replaceSelection(sendInfo + "\n");
		receiveText.setEditable(false);
	}
	protected JPanel getTitlePanel() {
		if (titlePanel == null) {
			titlePanel = new TitlePanel();
			titlePanel.setOpaque(false);
			titlePanel.setLayout(new BorderLayout());
			titlePanel.setAutoscrolls(true);
			titlePanel.add(getLabel_3());
			titlePanel.add(getCloseButton(), BorderLayout.EAST);
		}
		return titlePanel;
	}
	protected JLabel getLabel_3() {
		if (label_3 == null) {
			label_3 = new JLabel();
			label_3.setForeground(Color.WHITE);
			label_3.setIcon(new ImageIcon(getClass().getResource(
			"/image/sysTray.png")));
			label_3.setText("ҵڲͨѶϵͳ");
			label_3.addMouseListener(new MouseAdapter() {
				public void mouseReleased(MouseEvent e) {
					cp = null;
				}
			});
			label_3.addMouseMotionListener(new MouseMotionAdapter() {
				public void mouseDragged(MouseEvent e) {
					if ((e.getModifiers() & e.BUTTON1_MASK) == e.BUTTON1_MASK) {
						if (cp == null)
							cp = e.getPoint();
						Point sp = e.getLocationOnScreen();
						sp.setLocation(sp.x - cp.x, sp.y - cp.y);
						setLocation(sp);
					}
				}
			});
		}
		return label_3;
	}
	protected JButton getCloseButton() {
		if (closeButton == null) {
			closeButton = new JButton();
			closeButton.setFocusPainted(false);
			closeButton.setBorderPainted(false);
			closeButton.setMargin(new Insets(0, 0, 0, 0));
			closeButton.setIcon(SwingResourceManager.getIcon(MainFrame.class,
					"/closeWB.gif"));
			closeButton.setContentAreaFilled(false);
			ImageIcon closeWB1 = new ImageIcon(getClass().getResource(
					"/closeWB.png"));
			ImageIcon closeWB2 = new ImageIcon(getClass().getResource(
					"/closeWB_R.png"));
			closeButton.setIcon(closeWB1);
			closeButton.setRolloverIcon(closeWB2);
			closeButton.addActionListener(new ActionListener() {
				public void actionPerformed(ActionEvent e) {
					setVisible(false);
				}
			});
		}
		return closeButton;
	}
	protected JPanel getContent() {
		if (content == null) {
			content = new JPanel();
			content.setBackground(new Color(0xE4F3FB));
			content.setBorder(new LineBorder(new Color(0x82BCD8), 2, false));
			content.setLayout(new BorderLayout());
			content.add(getTitlePanel(), BorderLayout.NORTH);
			content.add(mainPanel);
			mainPanel.setOpaque(false);
			mainPanel.setDividerSize(2);
			mainPanel.setResizeWeight(0.8);
			mainPanel.setOrientation(JSplitPane.VERTICAL_SPLIT);
			mainPanel.setLeftComponent(scrollPane);
			scrollPane.setViewportView(getReceiveText());
			receiveText
					.setBorder(new LineBorder(new Color(0x82BCD8), 1, false));
			receiveText.setFont(new Font("", Font.PLAIN, 12));
			receiveText.setInheritsPopupMenu(true);
			receiveText.setVerifyInputWhenFocusTarget(false);
			receiveText.setDragEnabled(true);
			receiveText.setMargin(new Insets(0, 0, 0, 0));
			receiveText.setEditable(false);
			getReceiveText().addComponentListener(new ComponentAdapter() {
				public void componentResized(final ComponentEvent e) {
					scrollPane.getVerticalScrollBar().setValue(
							getReceiveText().getHeight());
				}
			});
			getReceiveText().setDoubleBuffered(true);

			mainPanel.setRightComponent(panel_2);
			panel_2.setOpaque(false);
			panel_2.setLayout(new BorderLayout());

			panel_2.add(toolPanel, BorderLayout.NORTH);
			toolPanel.setOpaque(false);
			toolPanel.setLayout(new BorderLayout());
			toolPanel.add(toolBar);
			toolBar.setOpaque(false);
			toolBar.setFloatable(false);
			toolBar.add(button);
			button.setOpaque(false);

			button.addActionListener(toolListener);
			button.setToolTipText("ļ");
			button.setFocusPainted(false);
			button.setMargin(new Insets(0, 0, 0, 0));
			button.setIcon(toolbarPictureIcon);
			toolBar.add(toolFaceButton);
			toolFaceButton.setOpaque(false);
			toolFaceButton.addActionListener(toolListener);
			toolFaceButton.setToolTipText("ѡ");
			toolFaceButton.setFocusPainted(false);
			toolFaceButton.setMargin(new Insets(0, 0, 0, 0));
			toolFaceButton.setIcon(toolbarFaceIcon);
			toolBar.add(button_3);
			button_3.setOpaque(false);
			button_3.addActionListener(toolListener);
			button_3.setToolTipText("ѡ쳡");
			button_3.setFocusPainted(false);
			button_3.setMargin(new Insets(0, 0, 0, 0));
			button_3.setIcon(toolbarSceneIcon);
			toolBar.add(toolFontButton);
			toolFontButton.setContentAreaFilled(false);
			toolFontButton.addActionListener(toolListener);
			toolFontButton.setFocusPainted(false);
			toolFontButton.setMargin(new Insets(0, 0, 0, 0));
			toolFontButton.setIcon(toolbarFontIcon);
			toolFontButton.setToolTipText("ɫ͸ʽ");
			toolBar.add(messageMode);
			messageMode.setOpaque(false);
			messageMode.setText("Ϣģʽ");
			panel_2.add(panel_1);
			panel_1.setLayout(new BorderLayout());
			panel_1.add(scrollPane_1);
			scrollPane_1
					.setHorizontalScrollBarPolicy(ScrollPaneConstants.HORIZONTAL_SCROLLBAR_NEVER);
			sendText.setInheritsPopupMenu(true);
			sendText.setBorder(new LineBorder(new Color(0x82BCD8), 1, false));
			sendText.addKeyListener(new SendTextKeyListener());
			sendText.setVerifyInputWhenFocusTarget(false);
			sendText.setFont(new Font("", Font.PLAIN, 12));
			sendText.setMargin(new Insets(0, 0, 0, 0));
			sendText.setDragEnabled(true);
			sendText.requestFocus();
			scrollPane_1.setViewportView(getSendText());
			content.add(infoPanel, BorderLayout.EAST);
			infoPanel.setBorder(new LineBorder(new Color(0x82BCD8), 1, false));
			infoPanel.setOpaque(false);
			infoPanel.setLayout(new BorderLayout());

			infoPanel.add(label_1, BorderLayout.NORTH);
			label_1.setIcon(new ImageIcon(MainFrame.class
					.getResource("/image/telFrameImage/userHead.png")));
			JTextArea label=new JTextArea("û" + user.getName()
					+ "\n" + user.getHost()
					+ "\nIPַ"+ user.getIp());
			label.setEditable(false);
			label.setOpaque(false);
			infoPanel.add(label);
			content.add(panel, BorderLayout.SOUTH);
			panel.setOpaque(false);
			final FlowLayout flowLayout_1 = new FlowLayout();
			flowLayout_1.setAlignment(FlowLayout.LEFT);
			flowLayout_1.setVgap(3);
			flowLayout_1.setHgap(80);
			panel.setLayout(flowLayout_1);

			panel.add(sendButton);
			sendButton.setIcon(new ImageIcon(getClass().getResource("/image/telFrameImage/sendButton.png")));
			sendButton.setContentAreaFilled(false);
			sendButton.setBorderPainted(false);
			sendButton.addActionListener(new SendActionListener());

			panel.add(messageButton);
			messageButton.setIcon(new ImageIcon(getClass().getResource("/image/telFrameImage/messageButton.png")));
			messageButton.addActionListener(new MessageButtonActionListener());
			messageButton.setContentAreaFilled(false);
			messageButton.setBorderPainted(false);
		}
		return content;
	}
}
